;; Bigloo bindings for CURL library
;; $Id$
;; 
 
(module
  curl
  (extern
    (include #"curl/curl.h")                                          
    (include #"curl/types.h")
    (include #"curl/easy.h")
    (type CURL void "CURL")
    (type CURL* (pointer CURL) "CURL *")    
    (type CURLconnect void "CURLconnect")

(type
   CURLINFO (enum
(NONE "CURLINFO_NONE")
(EFFECTIVE_URL "CURLINFO_EFFECTIVE_URL")
(HTTP_CODE "CURLINFO_HTTP_CODE")
(TOTAL_TIME "CURLINFO_TOTAL_TIME")
(NAMELOOKUP_TIME "CURLINFO_NAMELOOKUP_TIME")
(CONNECT_TIME "CURLINFO_CONNECT_TIME")
(PRETRANSFER_TIME "CURLINFO_PRETRANSFER_TIME")
(SIZE_UPLOAD "CURLINFO_SIZE_UPLOAD")
(SIZE_DOWNLOAD "CURLINFO_SIZE_DOWNLOAD")
(SPEED_DOWNLOAD "CURLINFO_SPEED_DOWNLOAD")
(SPEED_UPLOAD "CURLINFO_SPEED_UPLOAD")
(HEADER_SIZE "CURLINFO_HEADER_SIZE")
(REQUEST_SIZE "CURLINFO_REQUEST_SIZE")
(SSL_VERIFYRESULT "CURLINFO_SSL_VERIFYRESULT")
(FILETIME "CURLINFO_FILETIME")
(CONTENT_LENGTH_DOWNLOAD "CURLINFO_CONTENT_LENGTH_DOWNLOAD")
(CONTENT_LENGTH_UPLOAD "CURLINFO_CONTENT_LENGTH_UPLOAD")
(LASTONE "CURLINFO_LASTONE")) 
"CURLINFO")
    
(type
   CURLOPT (enum
  (NOTHING "CURLOPT_NOTHING")
  (FILE "CURLOPT_FILE")
  (URL "CURLOPT_URL")
  (PORT "CURLOPT_PORT")
  (PROXY "CURLOPT_PROXY")
  (USERPWD "CURLOPT_USERPWD")
  (PROXYUSERPWD "CURLOPT_PROXYUSERPWD")
  (RANGE "CURLOPT_RANGE")
  (FLAGS "CURLOPT_FLAGS")
  (INFILE "CURLOPT_INFILE")
  (ERRORBUFFER "CURLOPT_ERRORBUFFER")
  (WRITEFUNCTION "CURLOPT_WRITEFUNCTION")
  (READFUNCTION "CURLOPT_READFUNCTION")
  (TIMEOUT "CURLOPT_TIMEOUT")
  (INFILESIZE "CURLOPT_INFILESIZE")
  (POSTFIELDS "CURLOPT_POSTFIELDS")
  (REFERER "CURLOPT_REFERER")
  (FTPPORT "CURLOPT_FTPPORT")
  (USERAGENT "CURLOPT_USERAGENT")
  (LOW_SPEED_LIMIT "CURLOPT_LOW_SPEED_LIMIT")
  (LOW_SPEED_TIME "CURLOPT_LOW_SPEED_TIME")
  (RESUME_FROM "CURLOPT_RESUME_FROM")
  (COOKIE "CURLOPT_COOKIE")
  (HTTPHEADER "CURLOPT_HTTPHEADER")
  (HTTPPOST "CURLOPT_HTTPPOST")
  (SSLCERT "CURLOPT_SSLCERT")
  (SSLCERTPASSWD "CURLOPT_SSLCERTPASSWD")
  (CRLF "CURLOPT_CRLF")
  (QUOTE "CURLOPT_QUOTE")
  (WRITEHEADER "CURLOPT_WRITEHEADER")
  (MOREDOCS "CURLOPT_MOREDOCS")
  (COOKIEFILE "CURLOPT_COOKIEFILE")
  (SSLVERSION "CURLOPT_SSLVERSION")
  (TIMECONDITION "CURLOPT_TIMECONDITION")
  (TIMEVALUE "CURLOPT_TIMEVALUE")
  (HTTPREQUEST "CURLOPT_HTTPREQUEST")
  (CUSTOMREQUEST "CURLOPT_CUSTOMREQUEST")
  (STDERR "CURLOPT_STDERR")
  (PROGRESSMODE "CURLOPT_PROGRESSMODE")
  (POSTQUOTE "CURLOPT_POSTQUOTE")
  (WRITEINFO "CURLOPT_WRITEINFO")
  (VERBOSE "CURLOPT_VERBOSE")
  (HEADER "CURLOPT_HEADER")
  (NOPROGRESS "CURLOPT_NOPROGRESS")
  (NOBODY "CURLOPT_NOBODY")
  (FAILONERROR "CURLOPT_FAILONERROR")
  (UPLOAD "CURLOPT_UPLOAD")
  (POST "CURLOPT_POST")
  (FTPLISTONLY "CURLOPT_FTPLISTONLY")
  (FTPAPPEND "CURLOPT_FTPAPPEND")
  (NETRC "CURLOPT_NETRC")
  (FOLLOWLOCATION "CURLOPT_FOLLOWLOCATION")
  (FTPASCII "CURLOPT_FTPASCII")
  (TRANSFERTEXT "CURLOPT_TRANSFERTEXT")
  (PUT "CURLOPT_PUT")
  (MUTE "CURLOPT_MUTE")
  (PROGRESSFUNCTION "CURLOPT_PROGRESSFUNCTION")
  (PROGRESSDATA "CURLOPT_PROGRESSDATA")
  (AUTOREFERER "CURLOPT_AUTOREFERER")
  (PROXYPORT "CURLOPT_PROXYPORT")
  (POSTFIELDSIZE "CURLOPT_POSTFIELDSIZE")
  (HTTPPROXYTUNNEL "CURLOPT_HTTPPROXYTUNNEL")
  (INTERFACE "CURLOPT_INTERFACE")
  (KRB "CURLOPT_KRB")
  (LEVEL "CURLOPT_LEVEL")
  (SSL_VERIFYPEER "CURLOPT_SSL_VERIFYPEER")
  (CAINFO "CURLOPT_CAINFO")
  (PASSWDFUNCTION "CURLOPT_PASSWDFUNCTION")
  (PASSWDDATA "CURLOPT_PASSWDDATA")
  (MAXREDIRS "CURLOPT_MAXREDIRS")
  (FILETIME "CURLOPT_FILETIME")
  (TELNETOPTIONS "CURLOPT_TELNETOPTIONS")
  (MAXCONNECTS "CURLOPT_MAXCONNECTS")
  (CLOSEPOLICY "CURLOPT_CLOSEPOLICY")
  (CLOSEFUNCTION "CURLOPT_CLOSEFUNCTION")
  (FRESH_CONNECT "CURLOPT_FRESH_CONNECT")
  (FORBID_REUSE "CURLOPT_FORBID_REUSE")
  (RANDOM_FILE "CURLOPT_RANDOM_FILE")
  (EGDSOCKET "CURLOPT_EGDSOCKET")
  (CONNECTTIMEOUT "CURLOPT_CONNECTTIMEOUT")
  (LASTENTRY "CURLOPT_LASTENTRY")) "CURLoption")
 
    
(type 
      CURLcode
      (enum 
(OK "CURLE_OK") 
(UNSUPPORTED_PROTOCOL "CURLE_UNSUPPORTED_PROTOCOL")
(FAILED_INIT "CURLE_FAILED_INIT") 
(URL_MALFORMAT "CURLE_URL_MALFORMAT") 
(URL_MALFORMAT_USER "CURLE_URL_MALFORMAT_USER") 
(COULDNT_RESOLVE_PROXY "CURLE_COULDNT_RESOLVE_PROXY") 
(COULDNT_RESOLVE_HOST "CURLE_COULDNT_RESOLVE_HOST") 
(COULDNT_CONNECT "CURLE_COULDNT_CONNECT") 
(FTP_WEIRD_SERVER_REPLY "CURLE_FTP_WEIRD_SERVER_REPLY") 
(FTP_ACCESS_DENIED "CURLE_FTP_ACCESS_DENIED") 
(FTP_USER_PASSWORD_INCORRECT "CURLE_FTP_USER_PASSWORD_INCORRECT") 
(FTP_WEIRD_PASS_REPLY "CURLE_FTP_WEIRD_PASS_REPLY") 
(FTP_WEIRD_USER_REPLY "CURLE_FTP_WEIRD_USER_REPLY") 
(FTP_WEIRD_PASV_REPLY "CURLE_FTP_WEIRD_PASV_REPLY") 
(FTP_WEIRD_227_FORMAT "CURLE_FTP_WEIRD_227_FORMAT") 
(FTP_CANT_GET_HOST "CURLE_FTP_CANT_GET_HOST")
(FTP_CANT_RECONNECT "CURLE_FTP_CANT_RECONNECT")
(FTP_COULDNT_SET_BINARY "CURLE_FTP_COULDNT_SET_BINARY")
(PARTIAL_FILE "CURLE_PARTIAL_FILE")
(FTP_COULDNT_RETR_FILE "CURLE_FTP_COULDNT_RETR_FILE")
(FTP_WRITE_ERROR "CURLE_FTP_WRITE_ERROR")
(FTP_QUOTE_ERROR "CURLE_FTP_QUOTE_ERROR")
(HTTP_NOT_FOUND "CURLE_HTTP_NOT_FOUND")
(WRITE_ERROR "CURLE_WRITE_ERROR")
(MALFORMAT_USER "CURLE_MALFORMAT_USER")
(FTP_COULDNT_STOR_FILE "CURLE_FTP_COULDNT_STOR_FILE")
(READ_ERROR "CURLE_READ_ERROR")
(OUT_OF_MEMORY "CURLE_OUT_OF_MEMORY")
(OPERATION_TIMEOUTED "CURLE_OPERATION_TIMEOUTED")
(FTP_COULDNT_SET_ASCII "CURLE_FTP_COULDNT_SET_ASCII")
(FTP_PORT_FAILED "CURLE_FTP_PORT_FAILED")
(FTP_COULDNT_USE_REST "CURLE_FTP_COULDNT_USE_REST")
(FTP_COULDNT_GET_SIZE "CURLE_FTP_COULDNT_GET_SIZE")
(HTTP_RANGE_ERROR "CURLE_HTTP_RANGE_ERROR")
(HTTP_POST_ERROR "CURLE_HTTP_POST_ERROR")
(SSL_CONNECT_ERROR "CURLE_SSL_CONNECT_ERROR")
(FTP_BAD_DOWNLOAD_RESUME "CURLE_FTP_BAD_DOWNLOAD_RESUME")
(FILE_COULDNT_READ_FILE "CURLE_FILE_COULDNT_READ_FILE")
(LDAP_CANNOT_BIND "CURLE_LDAP_CANNOT_BIND")
(LDAP_SEARCH_FAILED "CURLE_LDAP_SEARCH_FAILED")
(LIBRARY_NOT_FOUND "CURLE_LIBRARY_NOT_FOUND")
(FUNCTION_NOT_FOUND "CURLE_FUNCTION_NOT_FOUND")
(ABORTED_BY_CALLBACK "CURLE_ABORTED_BY_CALLBACK")
(BAD_FUNCTION_ARGUMENT "CURLE_BAD_FUNCTION_ARGUMENT")
(BAD_CALLING_ORDER "CURLE_BAD_CALLING_ORDER")
(HTTP_PORT_FAILED "CURLE_HTTP_PORT_FAILED")
(BAD_PASSWORD_ENTERED "CURLE_BAD_PASSWORD_ENTERED")
(TOO_MANY_REDIRECTS "CURLE_TOO_MANY_REDIRECTS")
(UNKNOWN_TELNET_OPTION "CURLE_UNKNOWN_TELNET_OPTION")
(TELNET_OPTION_SYNTAX "CURLE_TELNET_OPTION_SYNTAX") 
(LAST "CURL_LAST")) "CURLcode")

(curl-version::string () "curl_version")
(curl-easy-init::CURL* () "curl_easy_init")
(macro curl-easy-setopt::CURLcode (CURL* . ::cobj) "curl_easy_setopt")
(curl-easy-perform::CURLcode (CURL*) "curl_easy_perform")
(curl-easy-cleanup::void (CURL*) "curl_easy_cleanup")

(curl-easy-getinfo::CURLcode (CURL* CURLINFO . CURLINFO) "curl_easy_getinfo")

(type filedes (opaque) "FILE *")
(macro fopen::filedes (::string ::string) "fopen")
(macro fclose::int (::filedes) "fclose")
    )
  )
